<?php


namespace Repository;

use Doctrine\ORM\EntityManager;
use Util\InstanceProvider;
use Zeedhi\DevOps\Model\Traits\TQuery;

class Estado extends RepositoryBase
{

    use TQuery;

    const ENTITY_NAME = '\Teknisa\Model\Geral\Entities\Estado';
    /**
     * @var EntityManager
     */
    private $entityManager;

    public function __construct()
    {
        parent::__construct(self::ENTITY_NAME);
        $this->entityManager = InstanceProvider::getEntityManager();
    }

    public function ApiGetStateByCountry($countryIdFilter, $conditions = " "){
        $query = <<<SQL
        SELECT *
		  FROM ( SELECT E.SGESTADO, E.NMESTADO, E.CDPAIS
                   FROM ESTADO E
                  WHERE 1 = 1
		            $countryIdFilter
               ORDER BY E.NMESTADO)
         WHERE 1=1
		       $conditions
SQL;

        $result = $this->entityManager->getConnection()->fetchAll($query);
        return ($result) ? $result : array();
    }

}
