<?php


namespace Repository;

use Doctrine\ORM\EntityManager;
use Util\InstanceProvider;
use Zeedhi\DevOps\Model\Traits\TQuery;

class Lista extends RepositoryBase
{

    use TQuery;

    const ENTITY_NAME = '\Teknisa\Model\Geral\Entities\Lista';
    /**
     * @var EntityManager
     */
    private $entityManager;

    public function __construct()
    {
        parent::__construct(self::ENTITY_NAME);
        $this->entityManager = InstanceProvider::getEntityManager();
    }

    public function findLista($listaFili){
        $query = <<<SQL
       SELECT COUNT(*) as "LISTA"
         FROM lista
        WHERE NRLISTA = :lista
SQL;
        $params = array(
            "lista" => $listaFili
        );
        $result = $this->entityManager->getConnection()->fetchAll($query,$params);
        return ($result) ? $result[0] : array();
    }

}
