<?php


namespace Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use Util\InstanceProvider;
use Zeedhi\DevOps\Model\Traits\TQuery;

class Organizacao extends RepositoryBase
{

    use TQuery;

    const ENTITY_NAME = '\Teknisa\Model\Geral\Entities\Organizacao';
    /**
     * @var EntityManager
     */
    private $entityManager;

    public function __construct()
    {
        parent::__construct(self::ENTITY_NAME);
        $this->entityManager = InstanceProvider::getEntityManager();
    }

    public function getOrganizacaoLogin($nrparcnegocio){
        $query = <<<SQL
    SELECT NRORG FROM ORGANIZACAO WHERE NRPARCNEGOCIO = $nrparcnegocio
SQL;

        $result = $this->entityManager->getConnection()->fetchAll($query);
        return ($result) ? $result[0] : array();
    }

    public function getOrganizacao($nrparcnegocio){
        $query = <<<SQL
    SELECT NRORG, NMORGANIZACAO,NRORGPRINCIPAL FROM ORGANIZACAO WHERE NRPARCNEGOCIO = $nrparcnegocio
SQL;

        $result = $this->entityManager->getConnection()->fetchAll($query);
        return ($result) ? $result[0] : array();
    }

    public function getOrganizacaoByNrorg($nrorg){
        $query = <<<SQL
    SELECT NRORG, NMORGANIZACAO,NRORGPRINCIPAL FROM ORGANIZACAO WHERE NRORG = $nrorg
SQL;

        $result = $this->entityManager->getConnection()->fetchAll($query);
        return ($result) ? $result[0] : array();
    }

    public function validateLinhaProduto($nrorg ,$cdlinpclie){
        $query = <<<SQL
                SELECT (COP.IDLPROCLINPC || '/' ||  COP.IDLPROCLINPC) AS IDMLPROCLINPC
                  FROM CONTRATOLINP COP
                  JOIN CLIENTE C ON COP.CDCLIENTE = C.CDCLIENTE
                  JOIN ORGANIZACAO O ON O.NRPARCNEGOCIO = C.NRPARCNEGOCIO AND O.NRORG = :NRORG
                  WHERE COP.DTCONTLINPRESC IS NULL
                  AND CDLINPCLIE IN (:CDLINPCLIE)
                  GROUP BY COP.IDLPROCLINPC,COP.IDLPROCLINPC
SQL;
        $params = array(
            "NRORG" => $nrorg,
            "CDLINPCLIE" => $cdlinpclie,
        );

        $types = array(
            "CDLINPCLIE" => Connection::PARAM_STR_ARRAY
        );

        return $this->entityManager->getConnection()->fetchAll($query, $params, $types);
    }

}
